# define NAME 2
# define STRING 3
# define ICON 4
# define FCON 5
# define PLUS 6
# define MINUS 8
# define MUL 11
# define AND 14
# define OR 17
# define ER 19
# define QUEST 21
# define COLON 22
# define ANDAND 23
# define OROR 24
# define ASOP 25
# define RELOP 26
# define EQUOP 27
# define DIVOP 28
# define SHIFTOP 29
# define INCOP 30
# define UNOP 31
# define STROP 32
# define TYPE 33
# define CLASS 34
# define STRUCT 35
# define RETURN 36
# define GOTO 37
# define IF 38
# define ELSE 39
# define SWITCH 40
# define BREAK 41
# define CONTINUE 42
# define WHILE 43
# define DO 44
# define FOR 45
# define DEFAULT 46
# define CASE 47
# define SIZEOF 48
# define ENUM 49
# define LP 50
# define RP 51
# define LC 52
# define RC 53
# define LB 54
# define RB 55
# define CM 56
# define SM 57
# define ASSIGN 58

# line 108 "cgram.y"
# include "mfile1"
int roflag = 0;
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;

# line 128 "cgram.y"
	static int fake = 0;
	static char fakename[NCHNAM+1];
# define YYERRCODE 256

# line 866 "cgram.y"


NODE *
mkty( t, d, s ) unsigned t; {
	return( block( TYPE, NIL, NIL, t, d, s ) );
	}

NODE *
bdty( op, p, v ) NODE *p; {
	register NODE *q;

	q = block( op, p, NIL, INT, 0, INT );

	switch( op ){

	case UNARY MUL:
	case UNARY CALL:
		break;

	case LB:
		q->in.right = bcon(v);
		break;

	case NAME:
		q->tn.rval = v;
		break;

	default:
		cerror( "bad bdty" );
		}

	return( q );
	}

dstash( n ){ /* put n into the dimension table */
	if( curdim >= DIMTABSZ-1 ){
		cerror( "dimension table overflow");
		}
	dimtab[ curdim++ ] = n;
	}

savebc() {
	if( psavbc > & asavbc[BCSZ-4 ] ){
		cerror( "whiles, fors, etc. too deeply nested");
		}
	*psavbc++ = brklab;
	*psavbc++ = contlab;
	*psavbc++ = flostat;
	*psavbc++ = swx;
	flostat = 0;
	}

resetbc(mask){

	swx = *--psavbc;
	flostat = *--psavbc | (flostat&mask);
	contlab = *--psavbc;
	brklab = *--psavbc;

	}

addcase(p) NODE *p; { /* add case to switch */

	p = optim( p );  /* change enum to ints */
	if( p->in.op != ICON ){
		uerror( "non-constant case expression");
		return;
		}
	if( swp == swtab ){
		uerror( "case not in switch");
		return;
		}
	if( swp >= &swtab[SWITSZ] ){
		cerror( "switch table overflow");
		}
	swp->sval = p->tn.lval;
	deflab( swp->slab = getlab() );
	++swp;
	tfree(p);
	}

adddef(){ /* add default case to switch */
	if( swtab[swx].slab >= 0 ){
		uerror( "duplicate default in switch");
		return;
		}
	if( swp == swtab ){
		uerror( "default not inside switch");
		return;
		}
	deflab( swtab[swx].slab = getlab() );
	}

swstart(){
	/* begin a switch block */
	if( swp >= &swtab[SWITSZ] ){
		cerror( "switch table overflow");
		}
	swx = swp - swtab;
	swp->slab = -1;
	++swp;
	}

swend(){ /* end a switch block */

	register struct sw *swbeg, *p, *q, *r, *r1;
	CONSZ temp;
	int tempi;

	swbeg = &swtab[swx+1];

	/* sort */

	r1 = swbeg;
	r = swp-1;

	while( swbeg < r ){
		/* bubble largest to end */
		for( q=swbeg; q<r; ++q ){
			if( q->sval > (q+1)->sval ){
				/* swap */
				r1 = q+1;
				temp = q->sval;
				q->sval = r1->sval;
				r1->sval = temp;
				tempi = q->slab;
				q->slab = r1->slab;
				r1->slab = tempi;
				}
			}
		r = r1;
		r1 = swbeg;
		}

	/* it is now sorted */

	for( p = swbeg+1; p<swp; ++p ){
		if( p->sval == (p-1)->sval ){
			uerror( "duplicate case in switch, %d", tempi=p->sval );
			return;
			}
		}

	genswitch( swbeg-1, swp-swbeg );
	swp = swbeg-1;
	}
short yyexca[] ={
-1, 1,
	0, -1,
	2, 23,
	11, 23,
	50, 23,
	57, 23,
	-2, 0,
-1, 19,
	56, 82,
	57, 82,
	-2, 7,
-1, 24,
	56, 81,
	57, 81,
	-2, 79,
-1, 26,
	56, 85,
	57, 85,
	-2, 80,
-1, 32,
	52, 46,
	-2, 44,
-1, 34,
	52, 38,
	-2, 36,
-1, 108,
	33, 18,
	34, 18,
	35, 18,
	49, 18,
	-2, 13,
-1, 279,
	33, 16,
	34, 16,
	35, 16,
	49, 16,
	-2, 14,
-1, 296,
	33, 17,
	34, 17,
	35, 17,
	49, 17,
	-2, 15,
	};
# define YYNPROD 186
# define YYLAST 1191
short yyact[]={

 210,  18, 261,  66, 230,  88,  87,  24,  27, 208,
  80,  92,  27,  78, 131,  46,  79,  21,  10,   9,
  14,  21, 165,   6,  97,  10,   9,  14,  95,  40,
  42, 130,  82,  81,  16, 199,  59, 109, 220, 221,
 225,  16, 229, 218, 219, 226, 227, 228, 232, 231,
  83,  75,  84,  74, 109, 255,  22,  27, 146, 222,
  22,  77,  27, 162,  45,  94,  21, 279, 111,  93,
  56,  21, 211,  99,  91,  19,  20, 132,  36, 296,
 155, 206,  95,  51,  27, 147, 151, 106,  36,  35,
 270,  41,  43,  21, 269, 310, 309, 303, 290, 157,
 265, 264, 203, 160, 163,  22,  90, 202,  70, 192,
  22, 297,  17,  71,  94, 167, 168, 169, 171, 173,
 175, 177, 179, 180, 182, 184, 186, 187, 188, 189,
 190, 101,  22, 155, 132, 159, 102, 194, 100,  98,
 139, 140, 141, 142, 143, 144, 147, 283,   8,  38,
 135, 285, 137,  39, 249, 191,  28, 156,  38,  69,
 205, 154,  39, 282, 113, 193, 110,  86,  88,  87,
 138, 234,  73, 235, 136, 236,  65, 237,  53, 238,
  57, 161, 239, 249, 240,  48, 241, 207,  48,  49,
 233, 201,  49, 132, 243,  82,  81,  48,  68, 158,
  33,  49, 153, 253, 196,  31, 305, 244, 288, 247,
 276, 201,  94,  83, 197,  84, 254, 262, 245,  27,
  72, 267, 257, 258, 259, 260,  64, 263,  21, 299,
 200, 250, 277, 148, 271, 280, 251, 252, 152,  57,
  10, 107,  14, 281,  10,   9,  14, 298,   4, 275,
 200, 274, 273, 284, 272, 152,  16, 287, 223, 248,
  16, 286,  96,  52,   9,  54,  26,  22,  30,  47,
 120, 278, 268, 291, 292, 262, 294, 293, 195, 230,
  88,  87,  60, 112,   7,  80,  67, 116,  78,  34,
 117,  79, 118,  29, 148, 120,  32, 224, 300, 108,
 306, 105, 104, 101, 262, 133, 307,  82,  81, 248,
  50,  26, 116, 220, 221, 225,  96, 229, 218, 219,
 226, 227, 228, 232, 231,  83,  25,  84,  61, 109,
 209, 230,  88,  87, 222,  44, 204,  80,  26, 117,
  78, 118,  89,  79, 120,  55,  58, 166, 164, 103,
  63,  62,  37,   3,   2, 150,  85,  11,  12,  82,
  81, 116, 119,   5,  23, 220, 221, 225,  13, 229,
 218, 219, 226, 227, 228, 232, 231,  83,  15,  84,
 117, 109, 118, 217, 215, 120, 222, 117, 122, 118,
 216, 123, 120, 124, 214, 127, 212, 125, 126, 128,
 114, 121, 116, 119, 213,   1,   0, 114, 121, 116,
 119,   0,   0,   0,   0,   0, 117,   0, 118,   0,
   0, 120,   0,   0, 122, 308,   0, 123,   0, 124,
 115, 127, 129, 125, 126, 128, 114, 121, 116, 119,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0, 117,   0, 118,   0,   0, 120,   0,   0,
 122, 304,   0, 123,   0, 124, 115, 127, 129, 125,
 126, 128, 114, 121, 116, 119,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
 117,   0, 118,   0, 117, 120, 118, 302, 122, 120,
   0, 123, 115, 124, 129, 127,   0, 125, 126, 128,
 114, 121, 116, 119, 114,   0, 116, 119,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0, 223,   0, 301, 117,   0, 118,   0,
 115, 120, 129,   0, 122,   0,   0, 123,   0, 124,
   0, 127, 295, 125, 126, 128, 114, 121, 116, 119,
 117,   0, 118,   0,   0, 120,   0,   0, 122,   0,
   0, 123,   0, 124,   0, 127,   0, 125, 126, 128,
 114, 121, 116, 119,   0, 223, 115,   0, 129,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
 115, 289, 129, 117,   0, 118,   0,   0, 120,   0,
   0, 122,   0,   0, 123,   0, 124,   0, 127,   0,
 125, 126, 128, 114, 121, 116, 119, 117,   0, 118,
   0,   0, 120,   0,   0, 122,   0,   0, 123,   0,
 124,   0, 127,   0, 125, 126, 128, 114, 121, 116,
 119,   0,   0, 115, 256, 129,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0, 117,   0, 118,
   0,   0, 120,   0,   0, 122, 246, 115, 123, 129,
 124,   0, 127, 242, 125, 126, 128, 114, 121, 116,
 119, 117,   0, 118,   0,   0, 120,   0,   0, 122,
   0,   0, 123,   0, 124,   0, 127,   0, 125, 126,
 128, 114, 121, 116, 119,   0,   0, 115,   0, 129,
   0,   0,   0,   0,   0,   0,   0, 117,   0, 118,
   0,   0, 120,   0,   0, 122, 198,   0, 123,   0,
 124, 115, 127, 129, 125, 126, 128, 114, 121, 116,
 119, 117,   0, 118,   0,   0, 120,   0,   0, 122,
   0,   0, 123,   0, 124,   0, 127,   0, 125, 126,
 128, 114, 121, 116, 119,   0,   0, 115,   0, 129,
  86,  88,  87,   0,   0,   0,  80,   0,   0,  78,
   0,   0,  79,  86,  88,  87,   0,   0,   0,  80,
   0,   0,  78, 129,   0,  79,   0,   0,  82,  81,
   0,   0,   0,   0,   0,   0,   0,   0,  86,  88,
  87,  82,  81,   0,  80,   0,  83,  78,  84,   0,
  79,  86,  88,  87,   0,   0, 185,  80,   0,  83,
  78,  84,   0,  79,   0,   0,  82,  81,   0, 183,
   0,   0,   0,   0,   0,   0,  86,  88,  87,  82,
  81,   0,  80,   0,  83,  78,  84,   0,  79,  86,
  88,  87,   0,   0, 181,  80,   0,  83,  78,  84,
   0,  79,   0,   0,  82,  81,   0, 178,   0,   0,
   0,   0,   0,   0,  86,  88,  87,  82,  81,   0,
  80,   0,  83,  78,  84,   0,  79,  86,  88,  87,
   0,   0, 176,  80,   0,  83,  78,  84,   0,  79,
   0,   0,  82,  81,   0, 174,   0,   0,   0,   0,
   0,   0,  86,  88,  87,  82,  81,   0,  80,   0,
  83,  78,  84,   0,  79,  86,  88,  87,   0,   0,
 172,  80,   0,  83,  78,  84,   0,  79,   0,   0,
  82,  81,   0, 170,   0,   0,   0,   0,   0,   0,
  86,  88,  87,  82,  81,   0,  80,   0,  83,  78,
  84,   0,  79,   0, 117,   0, 118, 266,   0, 120,
   0,  83, 122,  84,   0, 134,   0, 124,  82,  81,
   0,  10,   0,  14, 114, 121, 116, 119,   0,   0,
   0,   0,   0,  86,  88,  87,  83,  16,  84,  80,
   0,   0,  78,   0,   0,  79,  86,  88,  87, 117,
   0, 118,  80,   0, 120,  78,   0, 122,  79,   0,
   0,  82,  81,   0,   0,   0,   0,   0,   0, 114,
 121, 116, 119,   0,  82,  81,  86,  88,  87,  83,
   0,  84,  80,  76,   0,  78,   0,   0,  79,   0,
   0,   0,  83,   0,  84, 149,   0,  86,  88,  87,
   0,   0,   0,  80,  82,  81,  78,   0,   0,  79,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  83,   0,  84,  82,  81,   0,   0, 117,
   0, 118,   0,   0, 120,   0,   0, 122,   0,   0,
 123,   0, 124,  83, 127, 145, 125, 126,   0, 114,
 121, 116, 119, 117,   0, 118,   0,   0, 120,   0,
   0, 122,   0,   0, 123,   0, 124,   0,   0,   0,
 125,   0,   0, 114, 121, 116, 119, 117,   0, 118,
   0,   0, 120,   0,   0, 122,   0,   0, 123,   0,
 124,   0,   0,   0,   0,   0,   0, 114, 121, 116,
 119 };
short yypact[]={

-1000,  -8,-1000,-1000,-1000,  55,-1000, 207, 230,-1000,
 235,-1000,-1000, 153, 294, 148, 287,-1000,  32,  99,
-1000, 217, 217,  13, 138,  25,-1000, 213,-1000, 207,
 232, 207,-1000, 280,-1000,-1000,-1000,-1000, 175, 121,
 138,  99, 147, 108,  57,-1000,-1000,-1000, 169, 117,
1021,-1000,-1000,-1000,-1000,  49,-1000,  60,  83,-1000,
  15,  82,-1000, -15,-1000,-1000, 111,1064,-1000,-1000,
-1000, 281,-1000,-1000, 109, 755, 953, 120,1064,1064,
1064,1064,1064,1085, 978,1034, 205,-1000,-1000, 149,
 207,  77,-1000,  99, 135,-1000,-1000, 146, 280,-1000,
-1000,  99,-1000,-1000,-1000,-1000,   6,  47,-1000,-1000,
-1000, 755,-1000,-1000,1064,1064, 915, 902, 877, 864,
 839,1064, 826, 801, 788,1064,1064,1064,1064,1064,
  53,-1000, 755, 953,-1000,-1000,1064, 276,-1000, 120,
 120, 120, 120, 120, 120, 978, 163, 695, 200,-1000,
  51, 755,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,  24,-1000,-1000,-1000, 277, 211, 333, 755,-1000,
1064, 259,1064, 259,1064, 284,1064,-1000,1064, 488,
 381,1064, 988,1064,1033,1064,1161,1137, 671, 755,
 755, 141, 953,  53, 631,-1000, 158,1064,-1000, 129,
 180, 200,1064,-1000,  60,-1000,-1000,   2,-1000,-1000,
 607,-1000, 329, 329, 329, 329,1064, 329,  44,  43,
 940, 270,-1000,  37, 329, 204, 202,-1000, 201, 199,
 188,1064, 249,  10, 755, 755, 755, 755, 755, 755,
 755, 755,1064,-1000,-1000, 110,-1000, 165, 120,  92,
-1000, 100, 129, 755,-1000,-1000,-1000, 222,-1000,-1000,
 214, 157, 731,-1000,-1000,-1000,-1000, 554,  41,-1000,
-1000,-1000,1064,1064,1064,1064,-1000, 530,-1000,-1000,
  22,1113,-1000,-1000,  56, 197,-1000, 179, 329,-1000,
-1000, 484, 446,  40, 410,-1000,-1000,-1000, 155,1064,
-1000,-1000,-1000,1064,-1000,-1000, 374,  39,  38,-1000,
-1000 };
short yypgo[]={

   0, 405,   3, 404, 396, 394, 390, 384, 383, 378,
 368, 364,   0,   2,  61,  23, 363, 148, 358, 357,
  58,  35, 356,  11,  69,   7, 355, 354, 353,   1,
 352, 351, 350,  72, 349,  22,   9, 348, 347,  74,
 284, 346,  24,  36, 345, 342,  70, 336, 335,  76,
 328, 326, 310,  31,  14, 305, 302, 301, 299, 297,
 286 };
short yyr1[]={

   0,   1,   1,  27,  27,  28,  28,  30,  28,  31,
  32,  32,  35,  35,  37,  37,  38,  38,  38,  34,
  34,  34,  16,  16,  15,  15,  15,  15,  15,  40,
  17,  17,  17,  17,  17,  18,  18,   9,   9,  41,
  41,  43,  43,  19,  19,  10,  10,  44,  44,  46,
  46,  39,  47,  39,  23,  23,  23,  23,  23,  25,
  25,  25,  25,  25,  25,  24,  24,  24,  24,  24,
  24,  24,  11,  48,  48,  48,  29,  50,  29,  51,
  51,  49,  49,  49,  49,  49,  53,  53,  54,  54,
  42,  42,  45,  45,  52,  52,  55,  33,  33,  56,
  57,  58,  36,  36,  36,  36,  36,  36,  36,  36,
  36,  36,  36,  36,  36,  36,  36,  36,  36,  59,
  59,  59,   7,   4,   3,   5,   6,   8,  60,   2,
  13,  13,  26,  26,  12,  12,  12,  12,  12,  12,
  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,
  12,  12,  12,  12,  12,  12,  12,  12,  12,  14,
  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
  14,  14,  14,  14,  14,  14,  20,  21,  21,  21,
  21,  21,  21,  21,  22,  22 };
short yyr2[]={

   0,   2,   0,   1,   1,   2,   3,   0,   4,   2,
   2,   0,   2,   0,   3,   4,   3,   4,   0,   3,
   2,   2,   1,   0,   2,   2,   1,   1,   3,   1,
   1,   2,   3,   1,   1,   5,   2,   1,   2,   1,
   3,   1,   3,   5,   2,   1,   2,   1,   3,   2,
   1,   1,   0,   4,   1,   1,   3,   2,   1,   2,
   3,   3,   4,   1,   3,   2,   3,   3,   4,   3,
   3,   2,   2,   1,   3,   1,   1,   0,   4,   1,
   1,   1,   1,   3,   6,   1,   1,   3,   1,   4,
   0,   1,   0,   1,   0,   1,   1,   1,   1,   4,
   3,   1,   2,   1,   2,   2,   2,   7,   4,   2,
   2,   2,   2,   3,   3,   1,   2,   2,   2,   2,
   3,   2,   1,   4,   3,   4,   6,   4,   0,   2,
   1,   0,   1,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,
   4,   4,   4,   4,   4,   5,   3,   3,   1,   2,
   2,   2,   2,   2,   2,   2,   4,   4,   4,   2,
   3,   3,   1,   1,   1,   3,   2,   0,   2,   5,
   2,   3,   4,   3,   2,   2 };
short yychk[]={

-1000,  -1, -27, -28, 256, -16, -15, -40, -17,  34,
  33, -19, -18, -10,  35,  -9,  49,  57, -29, -24,
 -49,  11,  50, -11, -25, -51, 256,   2, -17, -40,
  33,  52,   2,  52,   2,  57,  56, -30,  50,  54,
 -25, -24, -25, -24, -48,  51,   2, 256,  50,  54,
 -52,  58,  50, -17,  33, -44, -46, -17, -41, -43,
   2, -50, -31, -32,  51,  55,  -2, -60,  51,  51,
  51,  56,  51,  55,  -2, -12,  52, -14,  11,  14,
   8,  31,  30,  48,  50, -22,   2,   4,   3, -45,
  57, -39, -23, -24, -25,  22, 256, -42,  56,  58,
 -49, -24, -33, -34, -56, -57, -15, 256, -58,  52,
  55, -12,   2,  55,  26,  56,  28,   6,   8,  29,
  11,  27,  14,  17,  19,  23,  24,  21,  25,  58,
 -53, -54, -12, -55,  52,  30,  54,  32,  50, -14,
 -14, -14, -14, -14, -14,  50, -20, -12, -17,  51,
 -26, -12,  50,  53, -46,  56,  22,  -2,  53, -43,
  -2, -39,  57,  57, -37, -35, -38, -12, -12, -12,
  58, -12,  58, -12,  58, -12,  58, -12,  58, -12,
 -12,  58, -12,  58, -12,  58, -12, -12, -12, -12,
 -12, -42,  56, -53, -12,   2, -20,  51,  51, -21,
  50,  11,  56,  51, -47,  -2,  57, -35, -36,  53,
 -12, -33,  -4,  -3,  -5,  -7,  -6,  -8,  41,  42,
  36,  37,  57, 256, -59,  38,  43,  44,  45,  40,
   2,  47,  46, -15, -12, -12, -12, -12, -12, -12,
 -12, -12,  22,  53, -54, -42,  55,  51, -14,  54,
  51, -21, -21, -12, -23,  53,  57, -36, -36, -36,
 -36, -13, -12, -36,  57,  57,  57, -12,   2,  57,
  53, -36,  50,  50,  50,  50,  22, -12,  22,  57,
 -29, -12,  53,  55,  -2,  51,  39,  43,  51,  57,
  57, -12, -12, -13, -12,  22,  57,  55,  50,  50,
 -36,  51,  51,  57,  51,  51, -12, -13,  51,  57,
  57 };
short yydef[]={

   2,  -2,   1,   3,   4,   0,  22,  26,  27,  29,
  30,  33,  34,   0,  45,   0,  37,   5,   0,  -2,
  76,   0,   0,   0,  -2,  94,  -2,  63,  24,  25,
  31,   0,  -2,   0,  -2,   6,  77,  11,   0, 128,
  59,  65,   0,   0,   0,  71,  73,  75,   0, 128,
   0,  95,  72,  28,  32,  92,  47,  50,  90,  39,
  41,   0,   8,   0,  66,  67,   0,   0,  64,  69,
  70,   0,  60,  61,   0,  83,   0, 158,   0,   0,
   0,   0,   0,   0,   0,   0, 172, 173, 174,   0,
  93,  49,  51,  54,  55, 128,  58,   0,  91, 128,
  78,  82,   9,  10,  97,  98,   0,   0,  -2, 101,
  68, 129,  74,  62,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  90,  86,  88,   0,  96, 159,   0,   0, 185, 160,
 161, 162, 163, 164, 165,   0,   0,   0, 177, 169,
   0, 132, 184,  43,  48,  52, 128,  57,  35,  40,
  42,   0,  20,  21,  13,   0,   0, 134, 135, 136,
   0, 137,   0, 138,   0, 139,   0, 140,   0, 141,
 142,   0, 143,   0, 144,   0, 145, 146,   0, 156,
 157,   0,  91,  90,   0, 171,   0,   0, 175, 176,
 177, 177,   0, 170,   0,  56,  19,   0,  12, 100,
   0, 103,   0,   0,   0,   0, 131,   0,   0,   0,
   0,   0, 115,   0,   0,   0,   0, 122,   0,   0,
 172,   0,   0,   0, 148, 149, 150, 151, 147, 152,
 153, 154,   0,  84,  87,   0, 168, 167, 166, 128,
 178,   0, 180, 133,  53,  99, 102, 104, 105, 106,
   0,   0, 130, 109, 110, 111, 112,   0,   0, 116,
 117, 118,   0,   0, 131,   0, 119,   0, 121,  -2,
   0, 155,  89, 181,   0, 183, 124,   0,   0, 113,
 114,   0,   0,   0,   0, 120,  -2, 182,   0,   0,
 108, 123, 125, 131, 127, 179,   0,   0,   0, 126,
 107 };
#
# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

int yydebug = 0; /* 1 for debugging */
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar = -1; /* current input token number */
int yynerrs = 0;  /* number of errors */
short yyerrflag = 0;  /* error recovery flag */

yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	yychar = -1;
	yynerrs = 0;
	yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &yyv[-1];

 yystack:    /* put a state and value onto the stack */

	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, yychar );
		if( ++yyps> &yys[YYMAXDEPTH] ) { yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = yyval;

 yynewstate:

	yyn = yypact[yystate];

	if( yyn<= YYFLAG ) goto yydefault; /* simple state */

	if( yychar<0 ) if( (yychar=yylex())<0 ) yychar=0;
	if( (yyn += yychar)<0 || yyn >= YYLAST ) goto yydefault;

	if( yychk[ yyn=yyact[ yyn ] ] == yychar ){ /* valid shift */
		yychar = -1;
		yyval = yylval;
		yystate = yyn;
		if( yyerrflag > 0 ) --yyerrflag;
		goto yystack;
		}

 yydefault:
	/* default state action */

	if( (yyn=yydef[yystate]) == -2 ) {
		if( yychar<0 ) if( (yychar=yylex())<0 ) yychar = 0;
		/* look through exception table */

		for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( yyerrflag ){

		case 0:   /* brand new error */

			yyerror( "syntax error" );
		yyerrlab:
			++yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
			      yystate = yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

			if( yydebug ) printf( "error recovery discards char %d\n", yychar );

			if( yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

		if( yydebug ) printf("reduce %d\n",yyn);
		yyps -= yyr2[yyn];
		yypvt = yypv;
		yypv -= yyr2[yyn];
		yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = yyr1[yyn];
		yyj = yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
		switch(yym){
			
case 2:
# line 134 "cgram.y"
ftnend(); break;
case 3:
# line 137 "cgram.y"
{
				if (roflag)
				{
					roflag = 0;
					locctr(DATA);
				}
				curclass = SNULL;  blevel = 0;
			} break;
case 4:
# line 146 "cgram.y"
{ curclass = SNULL;  blevel = 0; } break;
case 5:
# line 150 "cgram.y"
{  yypvt[-1].nodep->in.op = FREE; } break;
case 6:
# line 152 "cgram.y"
{ yypvt[-2].nodep->in.op = FREE; } break;
case 7:
# line 153 "cgram.y"
{
				defid( tymerge(yypvt[-1].nodep,yypvt[-0].nodep), curclass==STATIC?STATIC:EXTDEF );
				if (roflag)
				{
					werror("illegal use of readonly");
					roflag = 0;
				}
#ifndef LINT
#ifndef DELETE
				pfstab(stab[yypvt[-0].nodep->tn.rval].sname);
#endif
#endif
				} break;
case 8:
# line 166 "cgram.y"
{  
			    if( blevel ) cerror( "function level error" );
			    if( reached ) retstat |= NRETVAL; 
			    yypvt[-3].nodep->in.op = FREE;
			    ftnend();
			    } break;
case 11:
# line 177 "cgram.y"
{  blevel = 1; } break;
case 13:
# line 182 "cgram.y"
{  bccode();
			    locctr(PROG);
			    } break;
case 14:
# line 188 "cgram.y"
{  yypvt[-1].nodep->in.op = FREE; 
#ifndef LINT
#ifndef DELETE
			    plcstab(blevel);
#endif
#endif
			    } break;
case 15:
# line 196 "cgram.y"
{  yypvt[-2].nodep->in.op = FREE; 
#ifndef LINT
#ifndef DELETE
			    plcstab(blevel);
#endif
#endif
			    } break;
case 16:
# line 206 "cgram.y"
{  yypvt[-1].nodep->in.op = FREE; } break;
case 17:
# line 208 "cgram.y"
{  yypvt[-2].nodep->in.op = FREE; } break;
case 19:
# line 212 "cgram.y"
{ curclass = SNULL;  yypvt[-2].nodep->in.op = FREE; } break;
case 20:
# line 214 "cgram.y"
{ curclass = SNULL;  yypvt[-1].nodep->in.op = FREE; } break;
case 21:
# line 216 "cgram.y"
{  curclass = SNULL; } break;
case 23:
# line 220 "cgram.y"
{  yyval.nodep = mkty(INT,0,INT);  curclass = SNULL; } break;
case 24:
# line 223 "cgram.y"
{  yyval.nodep = yypvt[-0].nodep; } break;
case 26:
# line 226 "cgram.y"
{  yyval.nodep = mkty(INT,0,INT); } break;
case 27:
# line 228 "cgram.y"
{ curclass = SNULL ; } break;
case 28:
# line 230 "cgram.y"
{  yypvt[-2].nodep->in.type = types( yypvt[-2].nodep->in.type, yypvt[-0].nodep->in.type, UNDEF );
			    yypvt[-0].nodep->in.op = FREE;
			    } break;
case 29:
# line 237 "cgram.y"
{
				if (yypvt[-0].intval == READONLY)
				{
					roflag = 1;
					locctr(PROG);
					curclass = SNULL;
				}
				else
					curclass = yypvt[-0].intval;
			} break;
case 31:
# line 251 "cgram.y"
{  yypvt[-1].nodep->in.type = types( yypvt[-1].nodep->in.type, yypvt[-0].nodep->in.type, UNDEF );
			    yypvt[-0].nodep->in.op = FREE;
			    } break;
case 32:
# line 255 "cgram.y"
{  yypvt[-2].nodep->in.type = types( yypvt[-2].nodep->in.type, yypvt[-1].nodep->in.type, yypvt[-0].nodep->in.type );
			    yypvt[-1].nodep->in.op = yypvt[-0].nodep->in.op = FREE;
			    } break;
case 35:
# line 263 "cgram.y"
{ yyval.nodep = dclstruct(yypvt[-4].intval); } break;
case 36:
# line 265 "cgram.y"
{  yyval.nodep = rstruct(yypvt[-0].intval,0);  stwart = instruct; } break;
case 37:
# line 269 "cgram.y"
{  yyval.intval = bstruct(-1,0); stwart = SEENAME; } break;
case 38:
# line 271 "cgram.y"
{  yyval.intval = bstruct(yypvt[-0].intval,0); stwart = SEENAME; } break;
case 41:
# line 279 "cgram.y"
{  moedef( yypvt[-0].intval ); } break;
case 42:
# line 281 "cgram.y"
{  strucoff = yypvt[-0].intval;  moedef( yypvt[-2].intval ); } break;
case 43:
# line 285 "cgram.y"
{ yyval.nodep = dclstruct(yypvt[-4].intval);  } break;
case 44:
# line 287 "cgram.y"
{  yyval.nodep = rstruct(yypvt[-0].intval,yypvt[-1].intval); } break;
case 45:
# line 291 "cgram.y"
{  yyval.intval = bstruct(-1,yypvt[-0].intval);  stwart=0; } break;
case 46:
# line 293 "cgram.y"
{  yyval.intval = bstruct(yypvt[-0].intval,yypvt[-1].intval);  stwart=0;  } break;
case 49:
# line 301 "cgram.y"
{ curclass = SNULL;  stwart=0; yypvt[-1].nodep->in.op = FREE; } break;
case 50:
# line 303 "cgram.y"
{  if( curclass != MOU ){
				curclass = SNULL;
				}
			    else {
				sprintf( fakename, "$%dFAKE", fake++ );
				defid( tymerge(yypvt[-0].nodep, bdty(NAME,NIL,lookup( fakename, SMOS ))), curclass );
				werror("structure typed union member must be named");
				}
			    stwart = 0;
			    yypvt[-0].nodep->in.op = FREE;
			    } break;
case 51:
# line 318 "cgram.y"
{ defid( tymerge(yypvt[-1].nodep,yypvt[-0].nodep), curclass);  stwart = instruct; } break;
case 52:
# line 319 "cgram.y"
{yyval.nodep=yypvt[-2].nodep;} break;
case 53:
# line 320 "cgram.y"
{ defid( tymerge(yypvt[-4].nodep,yypvt[-0].nodep), curclass);  stwart = instruct; } break;
case 56:
# line 326 "cgram.y"
{  if( !(instruct&INSTRUCT) ) uerror( "field outside of structure" );
			    if( yypvt[-0].intval<0 || yypvt[-0].intval >= FIELD ){
				uerror( "illegal field size" );
				yypvt[-0].intval = 1;
				}
			    defid( tymerge(yypvt[-3].nodep,yypvt[-2].nodep), FIELD|yypvt[-0].intval );
			    yyval.nodep = NIL;
			    } break;
case 57:
# line 336 "cgram.y"
{  if( !(instruct&INSTRUCT) ) uerror( "field outside of structure" );
			    falloc( stab, yypvt[-0].intval, -1, yypvt[-2].nodep );  /* alignment or hole */
			    yyval.nodep = NIL;
			    } break;
case 58:
# line 341 "cgram.y"
{  yyval.nodep = NIL; } break;
case 59:
# line 346 "cgram.y"
{  umul:
				yyval.nodep = bdty( UNARY MUL, yypvt[-0].nodep, 0 ); } break;
case 60:
# line 349 "cgram.y"
{  uftn:
				yyval.nodep = bdty( UNARY CALL, yypvt[-2].nodep, 0 );  } break;
case 61:
# line 352 "cgram.y"
{  uary:
				yyval.nodep = bdty( LB, yypvt[-2].nodep, 0 );  } break;
case 62:
# line 355 "cgram.y"
{  bary:
				if( (int)yypvt[-1].intval <= 0 ) werror( "zero or negative subscript" );
				yyval.nodep = bdty( LB, yypvt[-3].nodep, yypvt[-1].intval );  } break;
case 63:
# line 359 "cgram.y"
{  yyval.nodep = bdty( NAME, NIL, yypvt[-0].intval );  } break;
case 64:
# line 361 "cgram.y"
{ yyval.nodep=yypvt[-1].nodep; } break;
case 65:
# line 364 "cgram.y"
{  goto umul; } break;
case 66:
# line 366 "cgram.y"
{  goto uftn; } break;
case 67:
# line 368 "cgram.y"
{  goto uary; } break;
case 68:
# line 370 "cgram.y"
{  goto bary; } break;
case 69:
# line 372 "cgram.y"
{ yyval.nodep = yypvt[-1].nodep; } break;
case 70:
# line 374 "cgram.y"
{
				if( blevel!=0 ) uerror("function declaration in bad context");
				yyval.nodep = bdty( UNARY CALL, bdty(NAME,NIL,yypvt[-2].intval), 0 );
				stwart = 0;
				} break;
case 71:
# line 380 "cgram.y"
{
				yyval.nodep = bdty( UNARY CALL, bdty(NAME,NIL,yypvt[-1].intval), 0 );
				stwart = 0;
				} break;
case 72:
# line 387 "cgram.y"
{
				/* turn off typedefs for argument names */
				stwart = SEENAME;
				if( stab[yypvt[-1].intval].sclass == SNULL )
				    stab[yypvt[-1].intval].stype = FTN;
				} break;
case 73:
# line 396 "cgram.y"
{ ftnarg( yypvt[-0].intval );  stwart = SEENAME; } break;
case 74:
# line 398 "cgram.y"
{ ftnarg( yypvt[-0].intval );  stwart = SEENAME; } break;
case 77:
# line 404 "cgram.y"
{yyval.nodep=yypvt[-2].nodep;} break;
case 79:
# line 408 "cgram.y"
{  defid( yypvt[-0].nodep = tymerge(yypvt[-1].nodep,yypvt[-0].nodep), curclass);
			    beginit(yypvt[-0].nodep->tn.rval);
			    } break;
case 81:
# line 415 "cgram.y"
{
				if (roflag)
					werror("readonly not initialised");
				nidcl( tymerge(yypvt[-1].nodep,yypvt[-0].nodep) );
			} break;
case 82:
# line 421 "cgram.y"
{
				if (roflag)
					werror("illegal use of readonly");
				defid(tymerge(yypvt[-1].nodep,yypvt[-0].nodep), uclass(curclass));
			} break;
case 83:
# line 428 "cgram.y"
{  doinit( yypvt[-0].nodep );
			    endinit(); } break;
case 84:
# line 431 "cgram.y"
{  endinit(); } break;
case 88:
# line 441 "cgram.y"
{  doinit( yypvt[-0].nodep ); } break;
case 89:
# line 443 "cgram.y"
{  irbrace(); } break;
case 94:
# line 455 "cgram.y"
{  werror( "old-fashioned initialization: use =" ); } break;
case 96:
# line 460 "cgram.y"
{  ilbrace(); } break;
case 99:
# line 470 "cgram.y"
{  
#ifndef LINT
#ifndef DELETE
			    prcstab(blevel);
#endif
#endif
			    --blevel;
			    if( blevel == 1 ) blevel = 0;
			    clearst( blevel );
			    checkst( blevel );
			    autooff = *--psavbc;
			    regvar = *--psavbc;
			    } break;
case 100:
# line 486 "cgram.y"
{  --blevel;
			    if( blevel == 1 ) blevel = 0;
			    clearst( blevel );
			    checkst( blevel );
			    autooff = *--psavbc;
			    regvar = *--psavbc;
			    } break;
case 101:
# line 496 "cgram.y"
{  if( blevel == 1 ) dclargs();
			    ++blevel;
			    if( psavbc > &asavbc[BCSZ-2] ) cerror( "nesting too deep" );
			    *psavbc++ = regvar;
			    *psavbc++ = autooff;
			    } break;
case 102:
# line 505 "cgram.y"
{ ecomp( yypvt[-1].nodep ); } break;
case 104:
# line 508 "cgram.y"
{ deflab(yypvt[-1].intval);
			   reached = 1;
			   } break;
case 105:
# line 512 "cgram.y"
{  if( yypvt[-1].intval != NOLAB ){
				deflab( yypvt[-1].intval );
				reached = 1;
				}
			    } break;
case 106:
# line 518 "cgram.y"
{  branch(  contlab );
			    deflab( brklab );
			    if( (flostat&FBRK) || !(flostat&FLOOP)) reached = 1;
			    else reached = 0;
			    resetbc(0);
			    } break;
case 107:
# line 525 "cgram.y"
{  deflab( contlab );
			    if( flostat & FCONT ) reached = 1;
			    ecomp( buildtree( CBRANCH, buildtree( NOT, yypvt[-2].nodep, NIL ), bcon( yypvt[-6].intval ) ) );
			    deflab( brklab );
			    reached = 1;
			    resetbc(0);
			    } break;
case 108:
# line 533 "cgram.y"
{  deflab( contlab );
			    if( flostat&FCONT ) reached = 1;
			    if( yypvt[-2].nodep ) ecomp( yypvt[-2].nodep );
			    branch( yypvt[-3].intval );
			    deflab( brklab );
			    if( (flostat&FBRK) || !(flostat&FLOOP) ) reached = 1;
			    else reached = 0;
			    resetbc(0);
			    } break;
case 109:
# line 543 "cgram.y"
{  if( reached ) branch( brklab );
			    deflab( yypvt[-1].intval );
			   swend();
			    deflab(brklab);
			    if( (flostat&FBRK) || !(flostat&FDEF) ) reached = 1;
			    resetbc(FCONT);
			    } break;
case 110:
# line 551 "cgram.y"
{  if( brklab == NOLAB ) uerror( "illegal break");
			    else if(reached) branch( brklab );
			    flostat |= FBRK;
			    if( brkflag ) goto rch;
			    reached = 0;
			    } break;
case 111:
# line 558 "cgram.y"
{  if( contlab == NOLAB ) uerror( "illegal continue");
			    else branch( contlab );
			    flostat |= FCONT;
			    goto rch;
			    } break;
case 112:
# line 564 "cgram.y"
{  retstat |= NRETVAL;
			    branch( retlab );
			rch:
			    if( !reached ) werror( "statement not reached");
			    reached = 0;
			    } break;
case 113:
# line 571 "cgram.y"
{  register NODE *temp;
			    idname = curftn;
			    temp = buildtree( NAME, NIL, NIL );
			    if(temp->in.type == TVOID)
				uerror("void function %s cannot return value",
					stab[idname].sname);
			    temp->in.type = DECREF( temp->in.type );
			    temp = buildtree( RETURN, temp, yypvt[-1].nodep );
			    /* now, we have the type of the RHS correct */
			    temp->in.left->in.op = FREE;
			    temp->in.op = FREE;
			    ecomp( buildtree( FORCE, temp->in.right, NIL ) );
			    retstat |= RETVAL;
			    branch( retlab );
			    reached = 0;
			    } break;
case 114:
# line 588 "cgram.y"
{  register NODE *q;
			    q = block( FREE, NIL, NIL, INT|ARY, 0, INT );
			    q->tn.rval = idname = yypvt[-1].intval;
			    defid( q, ULABEL );
			    stab[idname].suse = -lineno;
			    branch( stab[idname].offset );
			    goto rch;
			    } break;
case 119:
# line 602 "cgram.y"
{  register NODE *q;
			    q = block( FREE, NIL, NIL, INT|ARY, 0, LABEL );
			    q->tn.rval = yypvt[-1].intval;
			    defid( q, LABEL );
			    reached = 1;
			    } break;
case 120:
# line 609 "cgram.y"
{  addcase(yypvt[-1].nodep);
			    reached = 1;
			    } break;
case 121:
# line 613 "cgram.y"
{  reached = 1;
			    adddef();
			    flostat |= FDEF;
			    } break;
case 122:
# line 619 "cgram.y"
{  savebc();
			    if( !reached ) werror( "loop not entered at top");
			    brklab = getlab();
			    contlab = getlab();
			    deflab( yyval.intval = getlab() );
			    reached = 1;
			    } break;
case 123:
# line 628 "cgram.y"
{  ecomp( buildtree( CBRANCH, yypvt[-1].nodep, bcon( yyval.intval=getlab()) ) ) ;
			    reached = 1;
			    } break;
case 124:
# line 633 "cgram.y"
{  if( reached ) branch( yyval.intval = getlab() );
			    else yyval.intval = NOLAB;
			    deflab( yypvt[-2].intval );
			    reached = 1;
			    } break;
case 125:
# line 641 "cgram.y"
{  savebc();
			    if( !reached ) werror( "loop not entered at top");
			    if( yypvt[-1].nodep->in.op == ICON && yypvt[-1].nodep->tn.lval != 0 ) flostat = FLOOP;
			    deflab( contlab = getlab() );
			    reached = 1;
			    brklab = getlab();
			    if( flostat == FLOOP ) tfree( yypvt[-1].nodep );
			    else ecomp( buildtree( CBRANCH, yypvt[-1].nodep, bcon( brklab) ) );
			    } break;
case 126:
# line 652 "cgram.y"
{  if( yypvt[-3].nodep ) ecomp( yypvt[-3].nodep );
			    else if( !reached ) werror( "loop not entered at top");
			    savebc();
			    contlab = getlab();
			    brklab = getlab();
			    deflab( yyval.intval = getlab() );
			    reached = 1;
			    if( yypvt[-1].nodep ) ecomp( buildtree( CBRANCH, yypvt[-1].nodep, bcon( brklab) ) );
			    else flostat |= FLOOP;
			    } break;
case 127:
# line 664 "cgram.y"
{  savebc();
			    brklab = getlab();
			    ecomp( buildtree( FORCE, yypvt[-1].nodep, NIL ) );
			    branch( yyval.intval = getlab() );
			    swstart();
			    reached = 0;
			    } break;
case 128:
# line 673 "cgram.y"
{ yyval.intval=instruct; stwart=instruct=0; } break;
case 129:
# line 675 "cgram.y"
{  yyval.intval = icons( yypvt[-0].nodep );  instruct=yypvt[-1].intval; } break;
case 131:
# line 679 "cgram.y"
{ yyval.nodep=0; } break;
case 133:
# line 684 "cgram.y"
{  goto bop; } break;
case 134:
# line 688 "cgram.y"
{
			preconf:
			    if( yychar==RELOP||yychar==EQUOP||yychar==AND||yychar==OR||yychar==ER ){
			    precplaint:
				if( hflag ) werror( "precedence confusion possible: parenthesize!" );
				}
			bop:
			    yyval.nodep = buildtree( yypvt[-1].intval, yypvt[-2].nodep, yypvt[-0].nodep );
			    } break;
case 135:
# line 698 "cgram.y"
{  yypvt[-1].intval = COMOP;
			    goto bop;
			    } break;
case 136:
# line 702 "cgram.y"
{  goto bop; } break;
case 137:
# line 704 "cgram.y"
{  if(yychar==SHIFTOP) goto precplaint; else goto bop; } break;
case 138:
# line 706 "cgram.y"
{  if(yychar==SHIFTOP ) goto precplaint; else goto bop; } break;
case 139:
# line 708 "cgram.y"
{  if(yychar==PLUS||yychar==MINUS) goto precplaint; else goto bop; } break;
case 140:
# line 710 "cgram.y"
{  goto bop; } break;
case 141:
# line 712 "cgram.y"
{  goto preconf; } break;
case 142:
# line 714 "cgram.y"
{  if( yychar==RELOP||yychar==EQUOP ) goto preconf;  else goto bop; } break;
case 143:
# line 716 "cgram.y"
{  if(yychar==RELOP||yychar==EQUOP) goto preconf; else goto bop; } break;
case 144:
# line 718 "cgram.y"
{  if(yychar==RELOP||yychar==EQUOP) goto preconf; else goto bop; } break;
case 145:
# line 720 "cgram.y"
{  goto bop; } break;
case 146:
# line 722 "cgram.y"
{  goto bop; } break;
case 147:
# line 724 "cgram.y"
{  abop:
				yyval.nodep = buildtree( ASG yypvt[-2].intval, yypvt[-3].nodep, yypvt[-0].nodep );
				} break;
case 148:
# line 728 "cgram.y"
{  goto abop; } break;
case 149:
# line 730 "cgram.y"
{  goto abop; } break;
case 150:
# line 732 "cgram.y"
{  goto abop; } break;
case 151:
# line 734 "cgram.y"
{  goto abop; } break;
case 152:
# line 736 "cgram.y"
{  goto abop; } break;
case 153:
# line 738 "cgram.y"
{  goto abop; } break;
case 154:
# line 740 "cgram.y"
{  goto abop; } break;
case 155:
# line 742 "cgram.y"
{  yyval.nodep=buildtree(QUEST, yypvt[-4].nodep, buildtree( COLON, yypvt[-2].nodep, yypvt[-0].nodep ) );
			    } break;
case 156:
# line 745 "cgram.y"
{  werror( "old-fashioned assignment operator" );  goto bop; } break;
case 157:
# line 747 "cgram.y"
{  goto bop; } break;
case 159:
# line 751 "cgram.y"
{  yyval.nodep = buildtree( yypvt[-0].intval, yypvt[-1].nodep, bcon(1) ); } break;
case 160:
# line 753 "cgram.y"
{ ubop:
			    yyval.nodep = buildtree( UNARY yypvt[-1].intval, yypvt[-0].nodep, NIL );
			    } break;
case 161:
# line 757 "cgram.y"
{  if( ISFTN(yypvt[-0].nodep->in.type) || ISARY(yypvt[-0].nodep->in.type) ){
				werror( "& before array or function: ignored" );
				yyval.nodep = yypvt[-0].nodep;
				}
			    else goto ubop;
			    } break;
case 162:
# line 764 "cgram.y"
{  goto ubop; } break;
case 163:
# line 766 "cgram.y"
{
			    yyval.nodep = buildtree( yypvt[-1].intval, yypvt[-0].nodep, NIL );
			    } break;
case 164:
# line 770 "cgram.y"
{  yyval.nodep = buildtree( yypvt[-1].intval==INCR ? ASG PLUS : ASG MINUS,
						yypvt[-0].nodep,
						bcon(1)  );
			    } break;
case 165:
# line 775 "cgram.y"
{  yyval.nodep = doszof( yypvt[-0].nodep ); } break;
case 166:
# line 777 "cgram.y"
{  yyval.nodep = buildtree( CAST, yypvt[-2].nodep, yypvt[-0].nodep );
			    yyval.nodep->in.left->in.op = FREE;
			    yyval.nodep->in.op = FREE;
			    yyval.nodep = yyval.nodep->in.right;
			    } break;
case 167:
# line 783 "cgram.y"
{  yyval.nodep = doszof( yypvt[-1].nodep ); } break;
case 168:
# line 785 "cgram.y"
{  yyval.nodep = buildtree( UNARY MUL, buildtree( PLUS, yypvt[-3].nodep, yypvt[-1].nodep ), NIL ); } break;
case 169:
# line 787 "cgram.y"
{  yyval.nodep=buildtree(UNARY CALL,yypvt[-1].nodep,NIL); } break;
case 170:
# line 789 "cgram.y"
{  yyval.nodep=buildtree(CALL,yypvt[-2].nodep,yypvt[-1].nodep); } break;
case 171:
# line 791 "cgram.y"
{  if( yypvt[-1].intval == DOT ){
				if( notlval( yypvt[-2].nodep ) )uerror("structure reference must be addressable");
				yypvt[-2].nodep = buildtree( UNARY AND, yypvt[-2].nodep, NIL );
				}
			    idname = yypvt[-0].intval;
			    yyval.nodep = buildtree( STREF, yypvt[-2].nodep, buildtree( NAME, NIL, NIL ) );
			    } break;
case 172:
# line 799 "cgram.y"
{  idname = yypvt[-0].intval;
			    /* recognize identifiers in initializations */
			    if( blevel==0 && stab[idname].stype == UNDEF ) {
				register NODE *q;
				werror( "undeclared initializer name %.8s", stab[idname].sname );
				q = block( FREE, NIL, NIL, INT, 0, INT );
				q->tn.rval = idname;
				defid( q, EXTERN );
				}
			    yyval.nodep=buildtree(NAME,NIL,NIL);
			    stab[yypvt[-0].intval].suse = -lineno;
			} break;
case 173:
# line 812 "cgram.y"
{  yyval.nodep=bcon(0);
			    yyval.nodep->tn.lval = lastcon;
			    yyval.nodep->tn.rval = NONAME;
			    if( yypvt[-0].intval ) yyval.nodep->fn.csiz = yyval.nodep->in.type = ctype(LONG);
			    } break;
case 174:
# line 824 "cgram.y"
{  yyval.nodep = getstr(); /* get string contents */ } break;
case 175:
# line 826 "cgram.y"
{ yyval.nodep=yypvt[-1].nodep; } break;
case 176:
# line 830 "cgram.y"
{
			yyval.nodep = tymerge( yypvt[-1].nodep, yypvt[-0].nodep );
			yyval.nodep->in.op = NAME;
			yypvt[-1].nodep->in.op = FREE;
			} break;
case 177:
# line 838 "cgram.y"
{ yyval.nodep = bdty( NAME, NIL, -1 ); } break;
case 178:
# line 840 "cgram.y"
{ yyval.nodep = bdty( UNARY CALL, bdty(NAME,NIL,-1),0); } break;
case 179:
# line 842 "cgram.y"
{  yyval.nodep = bdty( UNARY CALL, yypvt[-3].nodep, 0 ); } break;
case 180:
# line 844 "cgram.y"
{  goto umul; } break;
case 181:
# line 846 "cgram.y"
{  goto uary; } break;
case 182:
# line 848 "cgram.y"
{  goto bary;  } break;
case 183:
# line 850 "cgram.y"
{ yyval.nodep = yypvt[-1].nodep; } break;
case 184:
# line 854 "cgram.y"
{  if( stab[yypvt[-1].intval].stype == UNDEF ){
				register NODE *q;
				q = block( FREE, NIL, NIL, FTN|INT, 0, INT );
				q->tn.rval = yypvt[-1].intval;
				defid( q, EXTERN );
				}
			    idname = yypvt[-1].intval;
			    yyval.nodep=buildtree(NAME,NIL,NIL);
			    stab[idname].suse = -lineno;
			} break;
		}
		goto yystack;  /* stack new state and value */

	}
