/	SUBTITLE	b-d2num.s	demand two numbers
/	Written by Steven Hardy on 15 April 1976
/	This function moves the two integers on top of the stack
/	to r1 and r2, converting them from pop11 format to dec format.
/	If they aren't two integers it reports an error
/	Modified 15th October 1976 to handle real
/	if either arg is real both args are realed and out in fr1 and fr2
/	caller is notified by error code
/
sd2num:
	mov	(r5),r2			/ copy arg2 to r2
	mov	2(r5),r1		/ copy arg1 to r1
	bit	r4,r1			/ is arg1 an integer?
	beq	1f			/ br if not
	asr	r1			/ convert arg1 to dec format
	bit	r4,r2			/ is arg2 an integer?
	beq	1f			/ br if not
	asr	r2			/ convert arg2 to dec format
	.if	real
	clc				/ clear condition code
	.endif
	rts	pc
	.if	real
1:
2:
	mov	(r5),r2			/ move arg2 to r2
	bit	r4,r2			/ is it an integer?
	beq	2f			/ br if not
	asr	r2			/ convert r2 to DEC format
	movif	r2,r2			/ real it
	br	3f			/ br to convert next
2:
	cmp	okey(r2),$kreal		/ is r2 already a real?
	bne	1f			/ br if not
	movf	(r2),r2			/ store arg2 in real reg
3:
	mov	2(r5),r1		/ arg1 to r1
	bit	r4,r1			/ is it an integer?
	beq	2f			/ br if not
	asr	r1			/ convert r1 to DEC format
	movif	r1,r1			/ real it
	br	3f
2:
	cmp	okey(r1),$kreal		/ is r1 a real number?
	bne	1f			/ br if not
	movf	(r1),r1			/ set up fr1
3:
	sec				/ set error code for caller
	rts	pc
	.endif
1:
	mov	#2045.,-(r5)		/ Error 45, two culprits
	jbr	soperror
