/	SUBTITLE	c-equal.s	equality of data structures
/	Written by Steven Hardy on 2nd September, 1977
/
	ksfunction
fequal:
	br	sequal
	wequal; false; rts pc
sequal:
	mov	(r5)+,r2		/ get args
	mov	(r5)+,r1
1:
	cmp	r1,r2			/ are they identical?
	bne	2f			/ br if not
	mov	$true,-(r5)		/ return true
	rts	pc
2:
	bit	r4,r1			/ arg1 an integer?
	bne	5f			/ br if so
	bit	r4,r2			/ arg2 an integer?
	bne	5f			/ br if so
	mov	okey(r1),r0		/ get key of first record to r0
	cmp	r0,okey(r2)		/ arg1 same type and size as arg2?
	bne	5f			/ br if not
	cmp	r0,$kword		/ are args words?
	bne	2f			/ br if not
	mov	oname(r1),r1		/ get strings
	mov	oname(r2),r2
	br	1b			/ loop back to start
2:
	tst	r0			/ byte, pointers or system function?
	beq	5f			/ br to return false if system function
	jgt	6f			/ br if bytes
	clr	r3			/ r3 is offset into record
	bic	$mbutsize,r0		/ clear all but size of key word
	asr	r0			/ bytes to words
	sub	$2,r0			/ ignore keyword and allow for iterative treatment of last field
	ble	3f			/ if only one field br to process it
2:					/ main processing loop
	mov	r0,-(r5)		/ save 'locals'
	mov	r1,-(r5)
	mov	r2,-(r5)
	mov	r3,-(r5)
	add	r3,r1			/ select field of arg1
	mov	(r1),-(r5)		/ push field
	add	r3,r2			/ same for arg2
	mov	(r2),-(r5)
	jsr	pc,scheck		/ check for stack overflow etc
	jsr	pc,sequal		/ check fields for equality
	cmp	(r5)+,$false		/ fields equal?
	beq	4f			/ br if not
	mov	(r5)+,r3		/ restore locals
	mov	(r5)+,r2
	mov	(r5)+,r1
	mov	(r5)+,r0
	add	$2,r3			/ update offset
	sob	r0,2b			/ loop back if more fields to consider
3:					/ here to process last field
	add	r3,r1			/ select last field of arg1
	mov	(r1),r1
	add	r3,r2			/ same for arg2
	mov	(r2),r2
	br	1b			/ back to start
4:					/ here on recursive test failure
	add	$10,r5			/ remove 'locals from stack
5:
	mov	$false,-(r5)		/ return false
	rts	pc
6:					/ here if they are byte records
	bic	$mbutsize,r0		/ get size of them
	asr	r0			/ bytes to words
	dec	r0			/ key word already checked
	beq	2f			/ if silly records return true
1:					/ here to check next field
	cmp	(r1)+,(r2)+		/ compare fields
	bne	5b			/ exit with false if no good
	sob	r0,1b			/ br back if more to do
2:	mov	$true,-(r5)		/ push true
	rts	pc			/ and exit
