/	SUBTITLE	c-match.s	match
/	Written by Steven Hardy on 23rd January, 1978
/	Because the 'text' area has overflowed a 4K boundary
/	I have moved this routine into the 'data' area:
	.if	bigdata
	.data
	.endif
	.if	match
/
	ksfunction
fmatch:
	jbr	smatch
	wmatch
	false
exit=.
	mov	(sp)+,pvar4
	mov	(sp)+,pvar3
	mov	(sp)+,pvar2
	mov	(sp)+,pvar1
	rts	pc
rtrue=.
	mov	$true,-(r5)
	jbr	exit
rfalse=.
	mov	$false,-(r5)
	jbr	exit
smatch:
	mov	pvar1,-(sp)		/ the pattern
	mov	pvar2,-(sp)		/ the data item
	mov	pvar3,-(sp)		/ the first element of the pattern
	mov	pvar4,-(sp)		/ the first element of the data
	mov	(r5)+,pvar2		/ store data
	mov	(r5)+,pvar1		/ store pattern
1:					/ beginning of main loop
	mov	pvar1,r0
	bit	r4,r0			/ is the pattern an atom?
	jne	2f			/ br if so
	cmp	okey(r0),$kpair
	jeq	3f			/ br if a list
2:					/ pattern is an atom
	cmp	r0,pvar2		/ is it equal to data
	jeq	rtrue			/ return true if so
	jbr	rfalse			/ otherwise return false
3:					/ pattern is not an atom
	mov	(r0)+,r1		/ first element of pattern to r1
	mov	(r0),pvar1		/ rest of pattern to pattern
	cmp	r1,$wquery		/ first element = "?"
	jne	3f			/ br if not
	mov	pvar2,r0		/ is data an atom?
	bit	r4,r0
	jne	rfalse			/ return false if so
	cmp	okey(r0),$kpair
	jne	rfalse
	mov	pvar1,r2		/ if not get next element of pattern
	mov	(r2)+,pvar3		/ store name of variable to be set
	mov	(r2),r2
	mov	r2,pvar1		/ and set pattern to rest
	mov	r2,-(r5)		/ push remainder of pattern
	mov	(r0)+,pvar4		/ store data item
	mov	(r0),pvar2		/ and remainder of data
	mov	(r0),-(r5)		/ push remainder of data
	cmp	(r2)+,$wcolon
	jne	2f			/ br if not
	mov	pvar4,-(r5)		/ push data item for testing
	mov	(r2),r2
	mov	(r2)+,-(r5)		/ push name of testing function
	mov	(r2),6(r5)		/ and alter pattern as stored on stack
	jsr	pc,svalof		/ get testing function
	jsr	pc,sapply		/ apply it
	cmp	(r5)+,$true		/ was it okay?
	jeq	2f			/ if so continue with match
	cmp	(r5)+,(r5)+		/ remove useless args from stack
	jbr	rfalse			/ and return false
2:					/ here to check rest before setting variable
	jsr	pc,smatch
	cmp	(r5)+,$true		/ was it okay?
	jne	rfalse			/ if not return false
	mov	pvar4,-(r5)		/ otherwise push data item
	mov	pvar3,-(r5)		/ and name of variable
	jsr	pc,uvalof		/ and set it
	jbr	rtrue			/ now return true
3:					/ here if not query
	cmp	r1,$wequal			/ is first element of pattern "="?
	jne	2f			/ br if not
	mov	pvar2,r1		/ is data an atom?
	bit	r4,r1
	jne	rfalse
	cmp	okey(r1),$kpair
	jne	rfalse
	mov	otl(r1),pvar2		/ ignore hd of data
	jbr	1b			/ continue matching
2:					/ here if not "?" or "="
	cmp	r1,$wquery2		/ might it be "??"
	jne	5f			/ br if not
	mov	pvar1,r1		/ get name of variable
	mov	(r1)+,pvar3		/ into pvar3
	mov	(r1),r1			/ onto rest of pattern
	mov	r1,pvar1		/ which must be stored
	cmp	r1,$nil			/ have we reached end of pattern?
	jne	3f			/ if not can't do quick check
	mov	pvar2,pvar4		/ set data used up
	jbr	4f			/ and go to setting point
3:					/ here if not quick check
	mov	$nil,pvar4		/ data used so far
3:					/ beginning of inner loop
	mov	pvar1,-(r5)		/ push remainder of pattern
	mov	pvar2,-(r5)		/ and data
	mov	pvar1,r0		/ but is it a checked setting?
	cmp	(r0)+,$wcolon
	jne	2f			/ br if not
	mov	(r0),r0
	mov	pvar4,-(r5)		/ push data matched so far
	mov	(r0)+,-(r5)		/ and name of checking function
	mov	(r0),6(r5)		/ alter pattern as stored on stack
	jsr	pc,svalof		/ get checking function
	jsr	pc,sapply		/ run it
	cmp	(r5)+,$true		/ okay?
	jeq	2f			/ br if so
	cmp	(r5)+,(r5)+		/ remove useless args from stack
	jbr	3f			/ br to try rest of pattern
2:					/ now to try recursive match
	jsr	pc,smatch
	cmp	(r5)+,$true		/ okay?
	jeq	4f			/ if so go to set variable
	mov	pvar2,r0		/ get next element of data
	bit	r4,r0			/ but is it a number
	jne	rfalse			/ if so there is no more data to try
	cmp	okey(r0),$kpair		/ is it a pair
	jne	rfalse			/ fail if not
	mov	pvar4,-(r5)		/ set up for concatenate
	mov	(r0)+,-(r5)		/ next element of data
	mov	(r0),pvar2		/ store rest of data
	mov	$nil,-(r5)		/ turn head into one element list
	jsr	pc,scnpair
	jsr	pc,sjnlist		/ add element to end of stored data items
	mov	(r5)+,pvar4		/ pop into variable for later use
	jbr	3b			/ back to main matching loop
4:					/ here to set variable
	mov	pvar4,-(r5)		/ push value
	mov	pvar3,-(r5)		/ and name
	jsr	pc,uvalof		/ set it
	jbr	rtrue			/ and success
5:					/ here if not "?", "=" or "??"
	cmp	r1,$weq		/ might it be "=="?
	jne	3f			/ br if not
	cmp	pvar1,$nil		/ quick check that there is more pattern
	jeq	rtrue			/ if not succeed
2:					/ beginning of inner loop
	mov	pvar1,-(r5)		/ push pattern
	mov	pvar2,-(r5)		/ and data
	jsr	pc,smatch		/ do they match
	cmp	(r5)+,$true
	jeq	rtrue			/ if so succeed
	mov	pvar2,r0		/ otherwise ignore first element of data
	bit	r4,r0
	jne	rfalse			/ if data is a number then fail
	cmp	okey(r0),$kpair
	jne	rfalse			/ ditto for non-lists
	mov	otl(r0),pvar2
	jbr	2b			/ back to matching loop
3:					/ here if not "?", "=", "??" or "=="
	mov	pvar2,r0		/ check data isn't an atom
	bit	r4,r0
	jne	rfalse
	cmp	okey(r0),$kpair
	jne	rfalse
	mov	r1,-(r5)		/ push first element of pattern
	mov	(r0)+,-(r5)		/ ditto for data
	mov	(r0),pvar2		/ store rest of data
	jsr	pc,smatch		/ recursive match on first elements
	cmp	(r5)+,$true		/ was it okay?
	jeq	1b			/ back to start if so
	jbr	rfalse			/ otherwise fail
	.endif
	.if	bigdata
	.text
	.endif
