turtle();
vars start image retina cortex;
[0 0]->start;


;;; hopto and hopdrawto replace jumpto and drawto by
    ;;; adding a start vector to any jumpto or drawto. used 
   ;;; primarily in samples;
function hopto(x,y);
	vars xpos ypos;
	x + hd(start)->xpos;
	y + hd(tl(start))->ypos;
	jumpto(xpos,ypos);
end;
	function hopdrawto(x,y);
	vars xpos ypos;
	x + hd(start)->xpos;
	y + hd(tl(start))->ypos;
	drawto(xpos,ypos);
end;


;;;    definitions of patterns to be recognised;
function one;
;;;the letter a in standard position;
	hopto(1,1); hopdrawto(1,5);
	hopdrawto(4,5); hopdrawto(4,1);
	hopto(1,3); hopdrawto(4,3);
end;
function two;
	hopto(2,1); hopdrawto(2,5);
	hopdrawto(5,5); hopdrawto(5,1);
	hopto(2,3); hopdrawto(5,3);
end;
function three;
	hopto(1,1);hopdrawto(1,5);hopdrawto(4,5);
	hopto(1,3);hopdrawto(4,3);
end;
function four;
	three();
	hopto(1,1);hopdrawto(4,1);
end;
function five;
	hopto(4,1);hopdrawto(1,1);
	hopdrawto(1,5);hopdrawto(4,5);
end;
function six;
	one(); hopto(6,1);
	hopdrawto(6,5); hopdrawto(9,5);
	hopto(6,3); hopdrawto(9,3);
end;

vars patterns;[one two three four five six ]->patterns;
   


;;;  sample(name) loads and displays a name-d pattern. samples()
    ;;; displays all the patterns currently assigned to patterns;
function sample(pattern);
	vars picture;
	newpicture(15,15);
        pattern();
	picture->image;
	display();
	nl(2);
end;
function samples;
	vars picture start patternlist caption num; patterns->patternlist;
	until patternlist==[] then
		newpicture(60,15);
        	[%0,0%]->start;
		0->num; []->caption;
		loopif num<4 and patternlist/==[] then
			apply(valof(hd(patternlist)));
			hd(start) + 15 -> hd(start);
			hd(patternlist)::caption -> caption;
			tl(patternlist) -> patternlist;
			num + 1->num
		close;
		picture -> image;
		display();
		rev(caption)->caption;
		until caption==[] then
			pr(hd(caption)); prstring('		');
			tl(caption)->caption;
		close;
		nl(2);
	close
end;
function exhibit(picture);
	display();
	nl(2);
end;



;;;	some templates;
function a;
	one();
end;
function f;
	three();
end;
function e;
	four();
end;
function c;
	five();
end;

vars templatelist; [a f e c]-> templatelist;



;;;  correlate loads a template to retina and matches it
    ;;; with current image. correlate is used by recognise() with all
;;; the templates currently assigned to templatelist;
function template(pattern);
	vars picture;newpicture(15,15);
	pattern();
	picture->retina;
end;
function correlate(pattern) => scores;
    template(pattern);
	vars picture;
	vars same missing extras i r;
      newpicture(15,15);
     picture -> cortex;
	0->missing; 0->extras;
        0->same;
   for 15 ->y step y-1 ->y till y<1 then
      for 1->x step x+1->x  till x>15 then
		image(x,y)->i; retina(x,y)->r;
		if i/==space and r/==space
		then "s"->picture(x,y); same + 1->same
		elseif i==space and r/==space
		then"m"->picture(x,y); missing+1->missing
		elseif i/==space and r==space
		then "e"->picture(x,y); extras + 1->extras
                close
      close
      close;
[% fnprops(pattern),same,missing,extras%]->scores
end;
function tabulate(scores);
vars quad;
	nl(1); prstring('template same missing extra');
	nl(1);
	until scores == [] then
	prstring('  ');
	hd(scores)->quad; pr(hd(quad));
	repeat 3 times
		tl(quad)->quad;
		prstring('	'); pr(hd(quad));
	close;
	nl(1); tl(scores)->scores
	close;
nl(1);
end;
function recognise;
;;;uses correlate to apply a list of templates to image...
;;;returns a list of scores [ different same] for each
;;;correlation;
	vars scorelist same different templist; templatelist->templist;
  	[]->scorelist;
	until templist ==[] then
        correlate(valof(hd(templist)))::scorelist->scorelist;
         tl(templist)->templist;
close;
tabulate(scorelist)
end;
