#include <param.h>
#include <tty.h>
#include <systm.h>
#include <conf.h>
#include <buf.h>

extern struct cblock cfree[];
extern struct cblock *cfreelist;
struct cblock *getcf();

/*
 * Character list get/put
 */
getc(p)
register struct clist *p;
{
	register struct cblock *bp;
	register int c, s;

	s = spl6();
	if (p->c_cc <= 0)
	{
		c = -1;
		p->c_cc = 0;
		p->c_cf = p->c_cl = NULL;
	}
	else
	{
		c = *p->c_cf++ & 0377;
		if (--p->c_cc<=0)
		{
			bp = (struct cblock *)(p->c_cf-1);
			bp = (struct cblock *) ((int)bp & ~CROUND);
			p->c_cf = NULL;
			p->c_cl = NULL;
			putcf(bp);
		}
		else if (((int)p->c_cf & CROUND) == 0)
		{
			bp = (struct cblock *)(p->c_cf);
			bp--;
			p->c_cf = bp->c_next->c_info;
			putcf(bp);
		}
	}
	splx(s);
	return(c);
}

/*
 * copy clist to buffer.
 * return number of bytes moved.
 */
q_to_b(q, cp, cc)
register struct clist *q;
register char *cp;
{
	register struct cblock *bp;
	register int s;
	char *acp;

	if (cc <= 0)
		return(0);
	s = spl6();
	if (q->c_cc <= 0)
	{
		q->c_cc = 0;
		q->c_cf = q->c_cl = NULL;
		return(0);
	}
	acp = cp;
	cc++;

	while (--cc)
	{
		*cp++ = *q->c_cf++;
		if (--q->c_cc <= 0)
		{
			bp = (struct cblock *)(q->c_cf-1);
			bp = (struct cblock *)((int)bp & ~CROUND);
			q->c_cf = q->c_cl = NULL;
			putcf(bp);
			break;
		}
		if (((int)q->c_cf & CROUND) == 0)
		{
			bp = (struct cblock *)(q->c_cf);
			bp--;
			q->c_cf = bp->c_next->c_info;
			putcf(bp);
		}
	}
	splx(s);
	return(cp-acp);
}


/*
 * Return count of contiguous characters
 * in clist starting at q->c_cf.
 * Stop counting if flag&character is non-null.
 */
ndqb(q, flag)
register struct clist *q;
{
register cc;
int s;

	s = spl6();
	if (q->c_cc <= 0)
	{
		cc = -q->c_cc;
		goto out;
	}
	cc = ((int)q->c_cf + CBSIZE) & ~CROUND;
	cc -= (int)q->c_cf;
	if (q->c_cc < cc)
		cc = q->c_cc;
	if (flag)
	{
		register char *p, *end;

		p = q->c_cf;
		end = p;
		end += cc;
		while (p < end)
		{
			if (*p & flag)
			{
				cc = (int)p;
				cc -= (int)q->c_cf;
				break;
			}
			p++;
		}
	}
out:
	splx(s);
	return(cc);
}


putc(c, p)
register struct clist *p;
{
	register struct cblock *bp;
	register char *cp;
	register s;

	s = spl6();
	if ((cp = p->c_cl) == NULL || p->c_cc < 0 )
	{
		if ((bp = getcf()) == NULL)
		{
			splx(s);
			return(-1);
		}
		p->c_cf = cp = bp->c_info;
	}
	else if (((int)cp & CROUND) == 0)
	{
		bp = (struct cblock *)cp - 1;
		if ((bp->c_next = getcf()) == NULL)
		{
			splx(s);
			return(-1);
		}
		bp = bp->c_next;
		cp = bp->c_info;
	}
	*cp++ = c;
	p->c_cc++;
	p->c_cl = cp;
	splx(s);
	return(0);
}



/*
 * copy buffer to clist.
 * return number of bytes not transfered.
 */
b_to_q(cp, cc, q)
register char *cp;
struct clist *q;
register int cc;
{
	register char *cq;
	register struct cblock *bp;
	register s, acc;

	if (cc <= 0)
		return(0);
	acc = cc;


	s = spl6();
	if ((cq = q->c_cl) == NULL || q->c_cc < 0)
	{
		if ((bp = getcf()) == NULL)
			goto out;
		q->c_cf = cq = bp->c_info;
	}

	while (cc)
	{
		if (((int)cq & CROUND) == 0)
		{
			bp = (struct cblock *) cq - 1;
			if ((bp->c_next = getcf()) == NULL) 
				goto out;
			bp = bp->c_next;
			cq = bp->c_info;
		}
		*cq++ = *cp++;
		cc--;
	}
out:
	q->c_cl = cq;
	q->c_cc += acc-cc;
	splx(s);
	return(cc);
}

/*
 * Initialize clist by freeing all character blocks, then count
 * number of character devices. (Once-only routine)
 */
cinit()
{
	register int ccp;
	register struct cblock *cp;
	register struct cdevsw *cdp;

	ccp = (int)cfree;
	ccp = (ccp+CROUND) & ~CROUND;
	for(cp=(struct cblock *)ccp; cp <= &cfree[NCLIST-1]; cp++)
		putcf(cp);
	ccp = 0;
	for(cdp = cdevsw; cdp->d_open; cdp++)
		ccp++;
	nchrdev = ccp;
}


/*
 * integer (2-byte) get/put
 * using clists
 */
getw(p)
register struct clist *p;
{
	register int s;

	if (p->c_cc <= 1)
		return(-1);
	s = getc(p);
	return(s | (getc(p)<<8));
}

putw(c, p)
register struct clist *p;
{
	register s;

	s = spl6();
	if (cfreelist==NULL)
	{
		splx(s);
		return(-1);
	}
	putc(c, p);
	putc(c>>8, p);
	splx(s);
	return(0);
}

/*
 * routine to grab a cblock from the freelist
 */
struct cblock *
getcf()
{
	register struct cblock *bp;
	register s;

	s = spl6();
	if ((bp = cfreelist) != NULL)
	{
		cfreelist = bp->c_next;
		bp->c_next = NULL;
	}
	splx(s);
	return(bp);
}

/*
 * routine to return a cblock to the freelist
 */
putcf(bp)
register struct cblock *bp;
{
	register s;

	s = spl6();
	bp->c_next = cfreelist;
	cfreelist = bp;
	splx(s);
}
